afterUTS/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('main.urls')),
    path('story8/', include ('story8.urls')),
    path('', include ('story9.urls')),
]

main/urls.py
from django.urls import path

from . import views

app_name = 'main'

urlpatterns = [
    path('', views.home, name='index'),
    
]

story8/urls.py
from django.urls import path

from . import views

app_name = 'story8'

urlpatterns = [
    path('', views.url_fuction, name="url_function"),
    path('data/', views.fungsi_data, name="fungsi_data"),
]

story9/urls.py
from django.urls import path

from . import views

app_name = 'story9'

urlpatterns = [
    path('login/', views.logIn, name='login'),
    path('signup/', views.signUp, name='signup'),
    path('logout/', views.logOut, name='logout'),
]

main/models.py
from django.db import models

# Create your models here.

story8/models.py
from django.db import models

# Create your models here.

story9/models.py
from django.db import models

# Create your models here.

story9/forms.py
from django import forms
from django.contrib.auth.models import User
from django.contrib.auth.forms import UserCreationForm, AuthenticationForm


class LoginForm(AuthenticationForm):
    username = forms.CharField(label="Username", widget=forms.TextInput(attrs={
        'class' : 'form-control',
        'id' : 'signIn-username',
        'placeholder' : 'Username',
        'type' : 'text',
        'style' : 'width: 20vw;',
        'required' : True
    }))

    password = forms.CharField(label="Password", widget=forms.TextInput(attrs={
        'class' : 'form-control',
        'id' : 'signIn-password',
        'placeholder' : 'Password',
        'type' : 'password',
        'style' : 'width: 20vw;',
        'required' : True
    }))

class SignUpForm(UserCreationForm):
    first_name = forms.CharField(label="First name", widget=forms.TextInput(attrs={
        'class' : 'form-control',
        'id' : 'signUp-firstName',
        'placeholder' : 'First name',
        'type' : 'text',
        'style' : 'width: 30vw;',
        'required' : True
    }))

    last_name = forms.CharField(label="Last name", widget=forms.TextInput(attrs={
        'class' : 'form-control',
        'placeholder' : 'Last name',
        'id' : 'signUp-lastName',
        'type' : 'text',
        'style' : 'width: 30vw;',
        'required' : True
    }))

    username = forms.CharField(label="Username", widget=forms.TextInput(attrs={
        'class' : 'form-control',
        'id' : 'signUp-username',
        'placeholder' : 'Username',
        'type' : 'text',
        'style' : 'width: 30vw;',
        'required' : True
    }))

    password1 = forms.CharField(label="Password", widget=forms.PasswordInput(attrs={
        'class' : 'form-control',
        'id' : 'signUp-password1',
        'placeholder' : 'Password',
        'type' : 'password',
        'style' : 'width: 30vw;',
        'required' : True
    }))
    
    password2 = forms.CharField(label="Confirm password", widget=forms.PasswordInput(attrs={
        'class' : 'form-control',
        'id' : 'signUp-password2',
        'placeholder' : 'Confirm Password',
        'type' : 'password',
        'style' : 'width: 30vw;',
        'required' : True
    }))

class Meta:
    model = User
    fields = ['first_name', 'last_name', 'username', 'password1', 'password2']

main/views.py
from django.shortcuts import render


def home(request):
    return render(request, 'index.html')

story8/views.py
from django.shortcuts import render
from django.http import HttpResponse
from django.http import JsonResponse
import requests
import json

# Create your views here.
def url_fuction (request):
    response = {}
    return render(request, 'search.html', response)

def fungsi_data(request):
    arg = request.GET['q']
    url_tujuan = 'https://www.googleapis.com/books/v1/volumes?q=' + arg
    r = requests.get(url_tujuan)
    data = json.loads(r.content)
    return JsonResponse(data, safe=False)

story9/views.py
from django.shortcuts import render, redirect
from .forms import LoginForm, SignUpForm
from django.contrib.auth.models import User
from django.contrib.auth import authenticate, login, logout
from django.contrib import messages
from django.contrib.auth.forms import UserCreationForm, AuthenticationForm


# Create your views here.
def logIn(request):
    if request.method == "POST":
        form = LoginForm(data = request.POST)

        if form.is_valid():
            usernameInput = request.POST["username"]
            passwordInput = request.POST["password"]

            print(usernameInput, passwordInput)
            user = authenticate(request, username = usernameInput, password = passwordInput)

            if user is not None:
                login(request, user)
                return redirect('/login/')

        else:
            messages.error(request, 'Invalid entry')

    else:
        form = LoginForm()

    context = {
        "form" : form,
    }

    return render(request, "login.html", context)

def signUp(request):
    if request.method == 'POST':
        form = SignUpForm(request.POST)

        if form.is_valid():
            user = form.save()
            login(request, user)
            return redirect("/login/")

        else:
            for msg in form.error_messages:
                messages.error(request, 'Invalid entry')

    else:
        form = SignUpForm()

    context = {
        'form' : form
    }

    return render(request, "signup.html", context)

def logOut(request):
    logout(request)
    return redirect("/login/")

main/templates/index.html
{% extends "base.html" %}
{% load static %}

{% block title %} Annisa Amalia | Story 7 {% endblock %}

{% block content %}

<div class="row">
    <div class="column greet col-ml-6 col-mt-3">
        {% include 'navbar.html' %}
        <div class="text-aja" style="margin-left: 3%;">
            <p id="sapaan" class="main-header">Hello there!</p> <hr>
            <br>
            <p id="info" style="color: #eeeeee;">Welcome to Chica's page 😊</p>
        </div>
    </div>
    <div class="column right-side col-ml-5 mt-5" style="margin-left: 45%;">
        <div id="aboutme" style="margin-top: 2%;">
            <h1>about me.</h1>
        </div>
        <div class="accordion-container" style="margin-right: 15%;">
            <!-- Activities -->
            <div class="accordion shadow" data-aos="fade-zoom-in">
                <div class="accordion-header">
                    <div class="accordion-header-left" id="activity-btn">
                        <img class="accordion-logo" src="{% static 'task.png' %}" alt="Aktivitas">
                        <div class="accordion-title">          Current activities</div>
                    </div>
                    <div class="accordion-buttons">
                        <div class="accordion-button-up">
                            <i class="fas fa-chevron-up"></i>
                        </div>
                        <div class="accordion-button-down">
                            <i class="fas fa-chevron-down"></i>
                        </div>
                    </div>
                </div>
                <div class="accordion-body hidden" id="activity-body">
                    <div class="activity-card-container">
                        <div class="activity-card" data-aos="fade-zoom-in">
                            <h3 class="activity-title">Nugas</h3>
                            <h5 class="activity-subtitle">I mean.. Aren't we all...</h5>
                        </div>
                        <div class="activity-card" data-aos="fade-zoom-in">
                            <h3 class="activity-title">Watching Start Up :p</h3>
                            <h5 class="activity-subtitle">#fyi this is my first on going series ever! (yea i'm following the hype tho)</h5>
                        </div>
                        <div class="activity-card" data-aos="fade-zoom-in">
                            <h3 class="activity-title">Buprok</h3>
                            <h5 class="activity-subtitle">I had actually taken off half of my prokers when this story was submitted :"D</h5>
                        </div>
                    </div>
                </div>
            </div>

            <!-- Organisasi -->
            <div class="accordion shadow" data-aos="fade-zoom-in">
                <div class="accordion-header">
                    <div class="accordion-header-left" id="experience-btn">
                        <img class="accordion-logo" src="{% static 'success.png' %}">
                        <div class="accordion-title">          Experience</div>
                    </div>
                    <div class="accordion-buttons">
                        <div class="accordion-button-up">
                            <i class="fas fa-chevron-up"></i>
                        </div>
                        <div class="accordion-button-down">
                            <i class="fas fa-chevron-down"></i>
                        </div>
                    </div>
                </div>
                <div class="accordion-body hidden" id="experience-body">
                    <div class="activity-card-container">

                        <div class="activity-card" data-aos="fade-zoom-in">
                            <h3 class="activity-title">
                                BETIS 2021<br>
                                <Small>humpar hehe</Small>
                            </h3>
                            <h5 class="activity-subtitle">
                                on going! wish me luck
                            </h5>
                        </div>

                        <div class="activity-card" data-aos="fade-zoom-in">
                            <h3 class="activity-title">
                                Compfest 13 insyaallah<br>
                                <Small>tetep di di is ei</Small>
                            </h3>
                            <h5 class="activity-subtitle">
                                belum bidding sih tp doain aja
                            </h5>
                        </div>

                        <div class="activity-card" data-aos="fade-zoom-in">
                            <h3 class="activity-title">
                                Compfest 12<br>
                                <small>di is ei</small>
                            </h3>
                            <h5 class="activity-subtitle">
                                ngestaf aja hehe
                            </h5>
                        </div>

                        <div class="activity-card" data-aos="fade-zoom-in">
                            <h3 class="activity-title">
                                and many others!<br>
                            </h3>
                            <h5 class="activity-subtitle">
                                kindly see my <a href="https://www.linkedin.com/in/annisa-amalia/">linkedin</a> profile for further info ;)
                            </h5>
                        </div>

                    </div>
                </div>
            </div>
            <!-- Achievement -->
            <div class="accordion shadow" data-aos="fade-zoom-in">
                <div class="accordion-header">
                    <div class="accordion-header-left" id="achievement-btn">
                        <img class="accordion-logo" src="{% static 'stars.png' %}">
                        <div class="accordion-title">          Achievements</div>
                    </div>
                    <div class="accordion-buttons">
                        <div class="accordion-button-up">
                            <i class="fas fa-chevron-up"></i>
                        </div>
                        <div class="accordion-button-down">
                            <i class="fas fa-chevron-down"></i>
                        </div>
                    </div>
                </div>

                <div class="accordion-body hidden" id="achievement-body">
                    <div class="activity-card-container">

                        <div class="activity-card" data-aos="fade-zoom-in">
                            <h3 class="activity-title">
                                1st and 2nd place<br><br>
                            </h3>
                            <h5 class="activity-subtitle">on some business plan contests with my (beloved) team!</h5>
                        </div>

                        <div class="activity-card" data-aos="fade-zoom-in">
                            <h3 class="activity-title">
                                3rd place of cerdas cermat 🥉 <br>
                                <small>with my team from MALAYSIAAA</small>
                            </h3>
                            <h5 class="activity-subtitle">Newbie Cup pacil 2019</h5>
                        </div>

                        <div class="activity-card" data-aos="fade-zoom-in">
                            <h3 class="activity-title">
                                to be continued! :)<br> <br>
                                <small>*hopefully*</small>
                            </h3>
                            <h5 class="activity-subtitle">wish me luck 😊</h5>
                        </div>

                    </div>
                </div>
            </div>

            <!-- Contact -->
            <div class="accordion shadow" data-aos="fade-zoom-in">
                <div class="accordion-header">
                    <div class="accordion-header-left" id="contact-btn">
                        <img class="accordion-logo" src="{% static 'loupe.png' %}">
                        <div class="accordion-title">          Find me on...</div>
                    </div>
                    <div class="accordion-buttons">
                        <div class="accordion-button-up">
                            <i class="fas fa-chevron-up"></i>
                        </div>
                        <div class="accordion-button-down">
                            <i class="fas fa-chevron-down"></i>
                        </div>
                    </div>
                </div>


                <div class="accordion-body hidden" id="contact-body">
                    <div class="activity-card-container">

                        <div class="activity-card" data-aos="fade-zoom-in">
                            <h3 class="activity-title">Email</h3>
                            <a class="activity-subtitle" href = "mailto: amalias.annisa@gmail.com">amalias.annisa@gmail.com</a>
                        </div>

                        <div class="activity-card" data-aos="fade-zoom-in">
                            <h3 class="activity-title">Instagram</h3>
                            <a class="activity-subtitle" href="https://www.instagram.com/annisaurus_/">annisaurus_</a>
                        </div>

                        <div class="activity-card" data-aos="fade-zoom-in">
                            <h3 class="activity-title">linkedin</h3>
                            <a class="activity-subtitle" href="https://www.linkedin.com/in/annisa-amalia/">Annisa Amalia Sholeka</a>
                        </div>

                        <div class="activity-card" data-aos="fade-zoom-in">
                            <h3 class="activity-title">or.. would you mind to go to ✨ Tangsel✨ ? 😉</h3>
                        </div>

                    </div>
                </div>
            </div>
        </div>
    </div>
</div>


{% endblock %}

{% block script %}  <script src="{% static 'js/accordion.js' %}"></script> {% endblock %}

story8/templates/search.html
{% extends 'base.html' %}
{% load static %}

{% block title %} Annisa Amalia | Story 8 {% endblock %}

<head>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <!-- <script src="{% static 'script.js' %}"></script> -->
    <title>BOOKS</title>
</head>

{% block content %}
{% include 'navbar.html' %}
<header class="text-center" style="color: wheat">
    <h1>Books</h1>
</header>

<div class="container">
    <form>
        <div class="row justify-content-md-center">
            <input type="text" class="form-control" id="keyword" placeholder="What book would you like to find?">
        </div>
    </form>

    <br>

    <div class="table-responsive table-borderless table-striped">
        <table class="table table-hover">
            <thead id="header" style="color: wheat;">
                <tr>
                    <th scope="col">Title</th>
                    <th scope="col">Cover</th>
                    <th scope="col">Author</th>
                    <th scope="col">Publisher</th>
                    <th scope="col">Published Date</th>
                </tr>
            </thead>
            <tbody id="hasil" style="background-color: whitesmoke;">

            </tbody>
        </table>
    </div>
</div>

{% endblock %}

{% block script %}
<script type="text/javascript">
    $("#keyword").keyup(function () {
        var isi_keyword = $("#keyword").val();
        console.log(isi_keyword);
        var url_utk_dipanggil = '/data?q=' + isi_keyword;
        // console.log(url_utk_dipanggil);
        $.ajax({
            url: 'https://www.googleapis.com/books/v1/volumes?q=' + isi_keyword,
            success: function (hasil) {
                // console.log(hasil.items);
                var obj_hasil = $("#hasil");
                obj_hasil.empty();
                for (i = 0; i < hasil.items.length; i++) {
                    var title = hasil.items[i].volumeInfo.title;
                    var thumbnails = hasil.items[i].volumeInfo.imageLinks.smallThumbnail;
                    var author = hasil.items[i].volumeInfo.authors[0];
                    var publisher = hasil.items[i].volumeInfo.publisher;
                    var published_date = hasil.items[i].volumeInfo.publishedDate;
                    console.log(title);
                    $("#hasil").append("<tr>" + "<td>" + title + "</a></td>" + 
                                                "<td><img src='" + thumbnails + "'></td>" +
                                                "<td>" + author + "</td>" +
                                                "<td>" + publisher + "</td>" +
                                                "<td>" + published_date + "</td>" +
                                            "</tr>");

                }
            }
        })

    });

</script>
{% endblock %}

story9/templates/login.html
{% extends 'base.html' %}

{% load static %}
{% block content %}

<div class="main-story10 d-flex flex-column justify-content-center">
    <div class="row">
        <div class="column greet col-ml-6 col-mt-3">
            {% include 'navbar.html' %}
            <div class="text-aja" style="margin-left: 3%;">
                <p id="sapaan" class="main-header">Hello there!</p> <hr>
                <br>
                <p id="info" style="color: #eeeeee;">Welcome to Chica's page 😊</p>
            </div>
        </div>
        <div class="column right-side col-ml-5 mt-5" style="margin-left: 43%;">
            {% if user.is_authenticated == False %}
            <div class="login content mx-5 my-5">
                {% if messages %}
                    {% for message in messages %}
                        <p>{{message}}</p>
                    {% endfor %}
                {% endif %}
                <div class="title">
                    <h3><b>Sign in</b></h3><br>
                </div>
                <div class="login-form">
                    <form method="POST">
                        {% csrf_token %} 
                        {{ form }}
                        <div>
                            <button type="submit" name="btn-login" id="btn-logIn" class="btn btn-dark mt-4">LOGIN</button>
                        </div>
                    </form>
                </div>

                <div class="info mt-5">
                    <p>
                        Don't have an account? <a class="sign-up-in-link" href="/signup"><strong>Sign up.</strong></a>
                    </p>
                </div>
            </div>

            {% else %}
                <div class="success mt-5 ml-5">
                    <div class="greeting mt-5">
                        <h3>Welcome,</h3>
                        <h1 style="font-weight: 800px;"><span class="highlight">{{user.username}}.</span></h1>
                        <h4 style="font-weight: 800px;"><span class="highlight">{{user.profile.bio}}.</span></h4>
                        <h4 style="font-weight: 800px;"><span class="highlight">{{user.profile.img}}.</span></h4>
                    </div>
                    <div class="btn-logout">
                        <form action="/logout">
                            <input type="submit" id="btn-logOut" class="btn btn-dark" value="Log out">
                        </form>
                    </div>
                </div>
            {% endif %}

        </div>
    </div>


</div>


{% endblock content %}

story9/templates/signup.html
{% extends 'base.html' %}

{% load static %}
{% block content %}

<div class="main-story10 d-flex flex-column justify-content-center">
    {% if messages %}
        {% for message in messages %}
            <p>{{message}}</p>
        {% endfor %}
    {% endif %}
    
    <div class="row">
        <div class="column greet col-ml-6 col-mt-3">
            {% include 'navbar.html' %}
            <div class="text-aja" style="margin-left: 3%;">
                <p id="sapaan" class="main-header">Hello there!</p> <hr>
                <br>
                <p id="info" style="color: #eeeeee;">Sign yourself up first.</p>
            </div>
        </div>
        <div class="column right-side col-ml-5 mt-5" style="margin-left: 43%;">
            <div class="login-content mx-5 my-5">

                <div class="title">
                    <h3><b>Create a new account</b></h3>
                </div>
            <br>
            <div class="register-form">
                <form method="POST">
                    {% csrf_token %} 
                    {{ form }}
                    <div>
                        <button type="submit" name="btn-signup" id='btn-signUp' class="btn btn-dark mt-4">SIGN UP</button>
                    </div>
                </form>
            </div>
        
            <div class="info mt-5">
                <p style="color: whitesmoke;">
                    Have an account already? <a class="sign-up-in-link" href="/login"><strong>Sign in.</strong></a>
                </p>
            </div>
        </div>
    </div> 
</div>

{% endblock content %}

templates/base.html
{% load static %}
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" type="text/css" href="{% static 'css/style.css' %}">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/css/bootstrap.min.css"
        integrity="sha384-TX8t27EcRE3e/ihU7zmQxVncDAy5uIKz4rEkgIXeMed4M0jlfIDPvg6uqKI2xXr2" crossorigin="anonymous">

    <!-- FONT -->
    <link href="https://fonts.googleapis.com/css2?family=Poppins:wght@200&display=swap" rel="stylesheet">
    <link rel="stylesheet"
        href="https://fonts.googleapis.com/css2?family=Josefin+Sans:ital,wght@0,200;0,300;0,400;0,500;0,600;0,700;1,200;1,300;1,400;1,500;1,600;1,700&family=Poppins:ital,wght@0,200;0,300;0,400;0,500;0,600;0,700;1,200;1,300;1,400&display=swap">

    <!-- JS -->
    <script src="{% static 'jquery-3.5.1.min.js' %}"></script>
    <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js"
        integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj"
        crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js"
            integrity="sha384-9/reFTGAW83EW2RDu2S0VKaIzap3H66lZH81PoYlFhbGU+6BZp6G7niu735Sk7lN"
            crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/js/bootstrap.min.js"
        integrity="sha384-w1Q4orYjBQndcko6MimVbzY0tgp4pWB4lZ7lr30WKz0vr/aWKhXdBNmNb5D92v7s"
        crossorigin="anonymous"></script>

    <script src="https://unpkg.com/aos@2.3.1/dist/aos.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.13.0/js/all.min.js"></script>
    <title>{% block title %}{% endblock %}</title>
    <script src="https://code.jquery.com/jquery-1.12.4.js"></script>
    <script src="https://code.jquery.com/ui/1.12.1/jquery-ui.js"></script>
</head>

<body>
    {% block content %}

    {% endblock %}

    {% block script %}

    {% endblock %}
</body>

</html>

templates/navbar.html
<div class="dropdown" style="margin-left: 2%; margin-top: 2%;">
    <button class="btn btn-secondary dropdown-toggle" type="button" id="dropdownMenuButton" data-toggle="dropdown"
        aria-haspopup="true" aria-expanded="false">
        Menu
    </button>
    <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
        <a class="dropdown-item" href="{% url 'main:index' %}">Story 7</a>
        <a class="dropdown-item" href="{% url 'story8:url_function' %}">Story 8</a>
        <a class="dropdown-item" href="{% url 'story9:login' %}">Story 9</a>
    </div>
</div>